#include "configulator.h"
#include "cfglr_log.h"
#include "cfglr_signaler_idf_event.h"

ESP_EVENT_DEFINE_BASE(CFGLR_EVENT_BASE);

#define TAG "CFGLR_SIG_IDF"

const char* cfglr_signal_names[] = {
  "CFGLR_SIGNAL_LOADED",
  "CFGLR_SIGNAL_CHANGE",
  "CFGLR_SIGNAL_DELETE",
};

uint8_t cfglr_signaler_idf_dispatch(cfglr_signaler_t *signaler, cfglr_element_t *element, cfglr_signal_e sig) {
  CFGLR_LOGI(TAG, "dispatch: %s", cfglr_signal_names[sig]);

  esp_event_post(CFGLR_EVENT_BASE, sig, element->data, element->datatype_size, portMAX_DELAY);

  return 0;
}
